package org.integratedmodelling.thinklab.script

import org.integratedmodelling.api.knowledge.IConcept
import org.integratedmodelling.api.modelling.IActiveDirectObservation
import org.integratedmodelling.api.modelling.IDirectObservation
import org.integratedmodelling.api.modelling.IObservableSemantics
import org.integratedmodelling.api.modelling.IState
import org.integratedmodelling.api.modelling.ISubject
import org.integratedmodelling.api.runtime.IContext
import org.integratedmodelling.api.runtime.ITask
import org.integratedmodelling.common.states.States

class DirectObservation extends Observation {

    DirectObservation(IDirectObservation obs, Binding binding) {
        super(obs, binding);
        name = obs.getName();
        wrap(obs);
    }

    private void setVar(String s, Object o) {
        ((org.integratedmodelling.engine.modelling.runtime.DirectObservation)obs).setVar(s,o);
    }
    
    private Object getVar(String s) {
        ((org.integratedmodelling.engine.modelling.runtime.DirectObservation)obs).getVar(s);
    }
    
    def wrap(IDirectObservation obs) {

        for (state in obs.getStates()) {
            setVar(state.getObservable().getSemantics().getFormalName(), new State(state, binding));
        }

        if (obs instanceof ISubject) {

            for (subject in ((ISubject)obs).getSubjects()) {
            }
            for (event in ((ISubject)obs).getEvents()) {
            }
            for (process in ((ISubject)obs).getProcesses()) {
            }
        }

        setVar("space", obs.getScale().getSpace() == null ? null : new Space(obs.getScale().getSpace(), binding));
        setVar("time", obs.getScale().getTime() == null ? null : new Time(obs.getScale().getTime(), binding));
        setVar("scale", new Scale(obs.getScale(), binding));
    }

    def leftShift(observation) {

        if (observation instanceof StateInfo) {

            String id = ((StateInfo)observation).name;

            if (((StateInfo)observation).getValue() != null) {

                IState state = ((IActiveDirectObservation)obs).getStaticState(((StateInfo)observation).getObservable());
                States.set(state, ((StateInfo)observation).getValue());
                State wrapped = new State(state, binding);
                setVar(id, wrapped);
                return wrapped;
                
            } else {

                /*
                 * TODO observe, then wrap in mediator if necessary
                 */
                IObservableSemantics observable = ((StateInfo)observation).getObservable();
                ITask task = ((org.integratedmodelling.common.knowledge.Observation)obs).getContext().focus(obs).observe(observable.getType());
                IContext context = task.finish();
                for (o in context.getNewObservations()) {
                    if (o instanceof IState) {
                        
                        IState state = (IState)o;
                        
                        /*
                         * TODO mediate! tedious....
                         */

                        State wrapped = new State(state, binding);
                        setVar(id, wrapped);
                        return wrapped;
                    }
                }
            }
        } else if (observation instanceof SubjectInfo) {
        } else if (observation instanceof EventInfo) {
        } else if (observation instanceof ProcessInfo) {
        } else if (observation instanceof IConcept) {

            /*
             * observe it! Careful - for now the focus() API requires obs to be
             * a subject, but for states it should allow any direct observations.
             */
            ITask task = ((org.integratedmodelling.common.knowledge.Observation)obs).getContext().focus(obs).observe(observation);
            IContext context = task.finish();
            for (o in context.getNewObservations()) {
                if (o instanceof IState) {
                } else {
                }
            }
        }
        null;
    }

    def propertyMissing(String id) {
        getVar(id);
    }
}
