package org.integratedmodelling.thinklab.script

import org.integratedmodelling.api.knowledge.IConcept
import org.integratedmodelling.common.vocabulary.NS
import org.integratedmodelling.exceptions.KlabRuntimeException

class ProcessInfo {
	
	String name;
	IConcept concept;
	
	ProcessInfo(IConcept concept) {
		if (!NS.isProcess(concept)) {
			throw new KlabRuntimeException("cannot use a non-process concept to create a process")
		}
		this.concept = concept;
	}
	
	def with(IConcept traitConcept) {
		this.concept = NS.addTraits(this.concept, Collections.singletonList(traitConcept), this.concept.getOntology());
		this;
	}
	
	def named(String n) {
		this.name = name;
		this;
	}
	
}
