package org.integratedmodelling.thinklab.script

import org.integratedmodelling.api.modelling.IScale
import org.integratedmodelling.api.modelling.scheduling.ITransition

/**
 * Works as a looper for the index over the current transition.
 * Simply do 
 * 
 * <pre>
 * for (n in scale) { 
 *      value = elevation[n\]; 
 * }
 * </pre>
 * or use scale.each { } semantics.
 * 
 * @author Ferd
 *
 */
class Scale {

    IScale scale;
    Binding binding;

    Scale(IScale scale, Binding binding) {
        this.scale = scale;
        this.binding = binding;
    }
    
    Iterator iterator() {
        ITransition t = null;
        if (binding.hasVariable('_transition')) {
            t = (ITransition)binding.getVariable('_transition');
        }
        return this.scale.getIndex(t).iterator();
    }
}
